org.cpsolver.studentsct.check

## Class InevitableStudentConflicts

- java.lang.Object
- - org.cpsolver.studentsct.check.InevitableStudentConflicts

-     public class InevitableStudentConflicts
      extends Object

  This class looks and reports all cases when a student cannot obtain a complete schedule because of time assignments of the requested courses. Course and section limits are not checked.
  Usage:

            InevitableStudentConflicts ch = new InevitableStudentConflicts(model);
            if (!ch.check()) ch.getCSVFile().save(new File("inevitable-conflicts.csv"));

  Parameters:

  Related Solver Parameters
  Parameter | Type | Comment
  --- | --- | ---
  InevitableStudentConflicts.DeleteInevitable | `Boolean` | If true, for each no-good (the smallest set of requests of the same student that cannot be assigned at the same time), the problematic request (i.e., the request that was not assigned by `InevitableStudentConflicts.StudentCheck`) is removed from the model.

  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `InevitableStudentConflicts.StudentCheck` Use branch & bound technique to find out whether a student can get a complete schedule.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static boolean` | `sDebug`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `InevitableStudentConflicts(StudentSectioningModel model)` Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `check(Assignment<Request,Enrollment> assignment)` Check model for inevitable student conflicts
    `CSVFile` | `getCSVFile()` Return report
    `StudentSectioningModel` | `getModel()` Return student sectioning model

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### sDebug

          public static boolean sDebug

  - ### Constructor Detail

    - #### InevitableStudentConflicts

          public InevitableStudentConflicts(StudentSectioningModel model)

      Constructor
      Parameters:
        `model` - student sectioning model

  - ### Method Detail

    - #### getModel

          public StudentSectioningModel getModel()

      Return student sectioning model
      Returns:
        problem model

    - #### getCSVFile

          public CSVFile getCSVFile()

      Return report
      Returns:
        generated report

    - #### check

          public boolean check(Assignment<Request,Enrollment> assignment)

      Check model for inevitable student conflicts
      Parameters:
        `assignment` - current assignment
      Returns:
        true if there are no inevitable student conflicts